<?php
  include 'fefunctions.php';
  include 'iocommand.php';

  start_session();

   /***********************************************************************
   *    Copyright � 2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

  $_SESSION["surveyView"] = "comparesurvey.php";
  set_time_limit(1000);
?>
<html>
<head>
  <title>HP Insight Diagnostics</title>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <link rel="stylesheet" type="text/css" href="stylesheets/main.css">
  <script type="text/javascript" src="dom-drag.js"></script>
  <script type="text/javascript" src="rpc.js"></script>
  <script type="text/javascript">
  function compareSurveys()
  {
    top.frames.dataFrame2.disableSurveySubTabs();
    top.frames.dataFrame1.disableTabs();
    document.compareForm.comparethis.value = 1;
  
    if (document.compareForm.changesOnly.checked)
      document.compareForm.changesOnly.value = "on";
    else
      document.compareForm.changesOnly.value = "off";
  
    document.compareForm.leftConfig.value = document.compareForm.configuration1.value;
    document.compareForm.rightConfig.value = document.compareForm.configuration2.value;
    document.compareForm.submit();
  }

  function initPage()
  {
    top.frames.dataFrame1.enableTabs();
    top.frames.dataFrame2.enableSurveySubTabs();
  }

  <?php BuildSaveDivJavascript("compareForm"); ?>
  </script>
  <script type="text/javascript" src="menufunctions.js"></script>
</head>
<body topmargin="0" marginheight="0" onload="initPage();">
<?php
  echo '<div id="wait" style="visibility: visible; display: inline;"><center><br>'.TR("MSG_PLEASE_WAIT").'<br><img src="hourglassani.gif"><br>'.TR("MSG_DEPENDING_ON_YOUR_SYSTEM_WAIT").'</center></div>';
?>
<form name="compareForm" method="POST" action="comparesurvey.php">
  <input type="hidden" name="changesOnly">
  <input type="hidden" name="surveyLevel">
  <input type="hidden" name="currentCategory">
  <input type="hidden" name="leftConfig">
  <input type="hidden" name="rightConfig">
  <input type="hidden" name="comparethis" value="1">
  <input type="hidden" name="save">
  <input type="hidden" name="target" value="">
  <input type="hidden" name="mount" value="">
  <input type="hidden" name="device" value="">
  <input type="hidden" name="filename" value="">
<?php
  CreateAboutDiv();
  CreateSaveDiv("comparesurvey.html");
  SaveFileScript("compareForm");
?>

<table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" bgcolor="white">
  <tr>
    <td width="5"></td>
    <td valign="top">
<?php
  if ($HTTP_POST_VARS['comparethis'] == '1' && $HTTP_POST_VARS['save'] == '')
  {
    $_SESSION['surveyLevel'] = $HTTP_POST_VARS['level'];
    $_SESSION['currentCategory'] = $HTTP_POST_VARS['category'];
    $_SESSION['changesOnly'] = $HTTP_POST_VARS['changesOnly'];
    $_SESSION['leftConfig'] = $HTTP_POST_VARS['configuration1'];
    $_SESSION['rightConfig'] = $HTTP_POST_VARS['rightConfig'];
  }

  echo '<table width="100%"';

  $ci = new client_info();
  if (strstr($ci->get_client_platform(), "indows"))
  {
    if (strstr($ci->get_client_browser(), "IE"))
      echo ' height="80%"';
    else
      echo ' height="80%"';
  }
  else
  {
    if (IsPhoenix())
      echo ' height="93%"';
    else
      echo ' height="430px"';
  }
  echo ' cellspacing="0" cellpadding="0">'."\n";

  echo '<tr><td bgcolor="#CCCCCC" width="5px" height="10px"></td><td colspan="2"></td><td bgcolor="#CCCCCC"></td></tr>';
  $idXml = new DomDocument($_SESSION['idResult']);
  $idXpath = @xpath_new_context($idXml->document_element());
  $categories = @xpath_eval($idXpath, '/diagOutput/category');  // get all the category objects

  echo '<tr><td bgcolor="#CCCCCC" width="5"></td><td width="5"></td><td valign="top" height="90px">'."\n";
  
  $getError = '';
  $getString = '';
  $manageGetString = '<getSurveyList/>';
  ExecuteIOCommand($_SESSION['diagsDirectory'].'hpdiagsai', $manageGetString, $getString, $getError);

  $xmldoc = new DomDocument($getString);
  $surveyList = $xmldoc->document_element();
  $surveyFilesXpath = @xpath_new_context($surveyList);
  $surveyFiles = @xpath_eval($surveyFilesXpath, '/surveyFile');
  $num_surveyFiles = count($surveyFiles->nodeset);

  if ($num_surveyFiles)
  {
    echo '<table width="100%"><tr><td><font color="black">&nbsp;&nbsp;&nbsp;&nbsp;<b>'.TR("MSG_VIEW_LEVEL").':&nbsp;&nbsp;&nbsp;</b><select name="level">'."\n";
    echo '<option name="Summary" value="Summary"';
    if ($_SESSION['surveyLevel'] == 'Summary' || $_SESSION['surveyLevel'] == '')
      echo ' selected';

    echo '>'.TR("MSG_SUMMARY").'</option>'."\n";
    echo '<option name="Advanced" value="Advanced"';
    if ($_SESSION['surveyLevel'] == 'Advanced')
      echo ' selected';

    echo '>'.TR("MSG_ADVANCED").'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>'."\n";
    echo '</select></td><td><b>'.TR("MSG_CATEGORIES").':</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<select name="category">';
    echo '<option name="All" value="All">'.TR("MSG_ALL").'</option>'."\n";
    
    $num_cats = count($categories->nodeset);

    for($c=0; $c < $num_cats; $c++)
    {
      $cat = $categories->nodeset[$c];
      $depth = 0; // xml tree depth
      $catCaption = $cat->get_attribute('caption');
	    $catName = $cat->get_attribute('name');
	    echo '<option name="'.$catName.'" value="'.$catName.'"';
      if ($_SESSION['currentCategory'] == $catName)
        echo " selected";

	    echo '>'.$catCaption.'&nbsp;&nbsp;&nbsp;</option>';
    }
    echo '</select></td>';
    echo '<td></td>';
    echo '</tr>';
    echo '<tr><td colspan="3" height="5px"></td></tr>';
    echo '<tr><td><b>'.TR("MSG_CONFIGURATION").' 1: ';
    echo '<select name="configuration1">'."\n";
    echo '<option name="surveybase" value="surveybase.xml">'.TR("MSG_ORIGINAL_CONFIGURATION").'</option>'."\n";

    if ($num_surveyFiles)
    {
      for ($s=0; $s < $num_surveyFiles; $s++)
      {
        $filename = $surveyFiles->nodeset[$s]->get_attribute('filename');
        $timeStamp = $surveyFiles->nodeset[$s]->get_attribute('timeStamp');
        $caption = $surveyFiles->nodeset[$s]->get_attribute('timeStampCaption');
        echo '<option name="'.$timeStamp.'" value="'.$filename.'"';
        if ($filename == $_SESSION['leftConfig'])
          echo ' selected';

        echo '>'.$caption.'</option>'."\n";
      }
    }
    echo '</select>'."\n".'</td>'."\n".'<td>'."\n\n";
    echo '<b>'.TR("MSG_CONFIGURATION").' 2:'."\n";
    echo '<select name="configuration2">'."\n";
    echo '<option name="surveycurrent" value="survey.lastwebsession.xml">'.TR("MSG_CURRENT_CONFIGURATION").'</option>'."\n";
    if ($num_surveyFiles)
    {
      for ($s=0; $s < $num_surveyFiles; $s++)
      {
        $filename = $surveyFiles->nodeset[$s]->get_attribute('filename');
        $timeStamp = $surveyFiles->nodeset[$s]->get_attribute('timeStamp');
        $caption = $surveyFiles->nodeset[$s]->get_attribute('timeStampCaption');
        echo '<option name="'.$timeStamp.'" value="'.$filename.'"';
        if ($filename == $_SESSION["rightConfig"])// || $RtimeStampCaption == $caption)
          echo ' selected';

        echo '>'.$caption.'</option>'."\n";
      }
    }
    echo '</select>'."\n";
    echo '</td><td>';
    echo MakeButton(TR("MSG_VIEW_COMPARE_RESULTS"),"compareSurveys()")."\n";
    echo '</td></tr><tr><td><img src="change.jpg"> - '.TR("MSG_CHANGE_IN_CONFIGURATION").'</td><td>'.TR("MSG_VIEW_CHANGES_ONLY");
    if ($_SESSION['changesOnly'] == 'on')
      echo '<input type="checkbox" name="changesOnly" checked></td></tr>';
    else
      echo '<input type="checkbox" name="changesOnly"></td></tr>';

    echo '</table>';
  }
  else // NO SURVEY FILES TO COMPARE
  {
    echo '<center><b>'.TR("MSG_NO_SURVEY_TO_COMPARE").'</b></center>';
  }

  echo '</td><td bgcolor="#CCCCCC" width="5ps"></td></tr><tr><td bgcolor="#CCCCCC" width="5px"></td><td width="5px"></td><td ';
  if (strstr($ci->get_client_platform(), 'indows'))
  {
    if (strstr($ci->get_client_browser(), 'IE'))
      echo ' height="310px">';
    else
      echo ' height="320px">';
  }
  else
  {
    if (IsPhoenix())
      echo ' height="320px">';
    else
      echo ' height="283px">';
  }
  
  if (($HTTP_POST_VARS['comparethis'] == '1' || $_SESSION['comparing'] == '1') && $HTTP_POST_VARS['save'] != '2')
  {
    echo '<div style="overflow: auto;';
    if (strstr($ci->get_client_platform(), 'indows'))
    {
      if (strstr($ci->get_client_browser(), 'IE'))
        echo ' height: 304px';
      else
        echo ' height: 320px';
    }
    else
    {
      if (IsPhoenix())
        echo ' height: 320px';
      else
        echo ' height: 283px';
    }
    if ($_SESSION['currentCategory'] == '' || $_SESSION['currentCategory'] == 'All')
      echo '; width: 930px';

    echo '">';

    $compareSurveyString = '<compareSurveyFiles leftFilename="'.$HTTP_POST_VARS["configuration1"].'" rightFilename="'.$HTTP_POST_VARS["rightConfig"].'"/>';
    ExecuteIOCommand($_SESSION['diagsDirectory'].'hpdiagsai', $compareSurveyString, $resultString, $compareError);

    $xmldoc = new DomDocument($resultString);
    $compareResult = $xmldoc->document_element();
    $filesMatch = $compareResult->get_attribute('filesMatch');

    ExecuteIOCommand($_SESSION['diagsDirectory'].'hpdiagsai', '<systemCall>chmod 777 surveycompare.left.xml</systemCall>', $resultString, $compareError);
    ExecuteIOCommand($_SESSION['diagsDirectory'].'hpdiagsai', '<systemCall>chmod 777 surveycompare.right.xml</systemCall>', $resultString, $compareError);

    if ($filesMatch)
    {
      echo TR("MSG_NO_CHANGES_FOUND");
    }
    else
    {									
      echo '<table width="100%"><tr><td>';
      if ($Ldom = LoadXmlDocument($_SESSION['diagsDirectory'].'surveycompare.left.xml'))
      {
        $LidXpath = xpath_new_context($Ldom->document_element());

        if ($_SESSION['currentCategory'] == '' || $_SESSION['currentCategory'] == 'All')
          $Lcategories = xpath_eval($LidXpath, '/category');  // get ALL the category objects
        else
          $Lcategories = xpath_eval($LidXpath, '/category[@name="'.$_SESSION['currentCategory'].'"]');  // get specific category object
  
        $num_Lcats = count($Lcategories->nodeset);
      }
    
      if ($Rdom = LoadXmlDocument($_SESSION['diagsDirectory'].'surveycompare.right.xml')) 
      {
        $RidXpath = xpath_new_context($Rdom->document_element());

        if ($_SESSION['currentCategory'] == '' || $_SESSION['currentCategory'] == 'All')
          $Rcategories = xpath_eval($RidXpath, '/category');  // get ALL the category objects
        else
          $Rcategories = xpath_eval($RidXpath, '/category[@name="'.$_SESSION['currentCategory'].'"]');  // get specific category object

        $num_Rcats = count($Rcategories->nodeset);
      }

      $numRows = 0;

      if ($HTTP_POST_VARS['save'] != 2)
      {
        echo '<table width="100%" cellspacing="1" cellpadding="0" style="border: 2px #968F89 solid;">';
        for($c=0; $c < $num_Lcats; $c++)
        {
          $Lcat = $Lcategories->nodeset[$c];
          $Rcat = $Rcategories->nodeset[$c];

          $depth = 0; // xml tree depth
          
          $LobjXpath = xpath_new_context($Lcat);
          $LnestedObjects = xpath_eval($LobjXpath, '/*');
	
          $RobjXpath = xpath_new_context($Rcat);
          $RnestedObjects = xpath_eval($RobjXpath, '/*');
        
          $num_LnestedObjs = count($LnestedObjects->nodeset);
          $num_RnestedObjs = count($RnestedObjects->nodeset);      
      
          for ($LR=0; $LR < $num_LnestedObjs && $LR < $num_RnestedObjs; $LR++)
          {
            $LnestedObj = $LnestedObjects->nodeset[$LR];
            $RnestedObj = $RnestedObjects->nodeset[$LR];
            printCompareContent($numRows, $LnestedObj, $RnestedObj, $depth, $bgcolor, $_SESSION['changesOnly']);
          }
        }
      }
      if ($numRows == 0)
        echo '<tr><td><center>'.TR("MSG_NO_CHANGES_FOUND").'</center></td></tr>';
    }
    echo '</table></td></tr></table></div>';
  }

  if ($HTTP_POST_VARS['save'] == '2')  // check if file exits
  {
    //Save_CheckIfFileExits($HTTP_POST_VARS["saveLocation"], $HTTP_POST_VARS["filename"], "compareForm") ;
    Save_CheckIfFileExists($_POST['target'], $_POST['device'], $_POST['mount'], $_POST['filename'], 'compareForm');
  }
  
  if ($HTTP_POST_VARS['save'] == '3')  // Save page
  {
    //  All this is to display the time stamp caption on the saved file instead of the select box
    $lefty = LoadXmlDocument($_SESSION['diagsDirectory'].$HTTP_POST_VARS['configuration1']);
    if ($lefty)
    {
      $LeftyXpath = xpath_new_context($lefty->document_element());
      $leftFile = @xpath_eval($LeftyXpath, '/'); 
      if (count($leftFile->nodeset))
        $caption1 = $leftFile->nodeset[0]->get_attribute('timeStampCaption');
    }
    $righty = LoadXmlDocument($_SESSION['diagsDirectory'].$HTTP_POST_VARS['configuration2']);
    if ($righty)
    {
      $RightyXpath = xpath_new_context($righty->document_element());
      $rightFile = @xpath_eval($RightyXpath, '/'); 
      if (count($rightFile->nodeset))
        $caption2 = $rightFile->nodeset[0]->get_attribute('timeStampCaption');
    }
      
    $oss = '<html>'."\n".'<head>'."\n".'<title>'.getComputerName().'</title>'."\n".'<style type="text/css">'."\n";
    $oss .= 'table { width: 100%; border: 2px solid #968F89; border-top: none; background-color: #FFFFFF; }'."\n";
    $oss .= 'tr { background-color: #FFFFFF; color: #000000; }'."\n";
    $oss .= 'tr.alt { background-color: #EEEEEE; }'."\n";
    $oss .= 'tr.change { color: #FF0000; }'."\n";
    $oss .= 'th { background-color: #968F89; color: #FFFFFF; text-align: left; }'."\n";
    $oss .= '</style>'."\n".'</head>'."\n".'<body>'."\n";
    $oss .= 'HP Insight Diagnostics '.TR('MSG_VERSION').' '.getBuildVersion().'<br>'.TR('MSG_COMPUTER_NAME').': '.getComputerName()."\n";
    $oss .= '<table cellspacing="0" cellpadding="0">'."\n";
    $oss .= '<tr><th colspan="2">'.$caption1.'</th><th colspan="2">'.$caption2.'</th></tr>';

    $compareResults = '';
    for($c=0; $c < $num_Lcats; $c++)
    {
      $Lcat = $Lcategories->nodeset[$c];
      $Rcat = $Rcategories->nodeset[$c];
      $LobjXpath = xpath_new_context($Lcat);
      $LnestedObjects = xpath_eval($LobjXpath, '/*');
      $RobjXpath = xpath_new_context($Rcat);
      $RnestedObjects = xpath_eval($RobjXpath, '/*');
      $num_LnestedObjs = count($LnestedObjects->nodeset);
      $num_RnestedObjs = count($RnestedObjects->nodeset);      

      $depth = 0; // xml tree depth
      $alt = false;
      
      for ($LR=0; $LR < $num_LnestedObjs && $LR < $num_RnestedObjs; $LR++)
      {
        $LnestedObj = $LnestedObjects->nodeset[$LR];
        $RnestedObj = $RnestedObjects->nodeset[$LR];
        outputCompareContent($compareResults, $LnestedObj, $RnestedObj, $depth, $bgcolor, $alt);
      }
    }

    $oss .= $compareResults;
    $oss .= '</table>'."\n".'</body>'."\n".'</html>';

    $result = SaveFile($_POST['filename'], $_POST['target'], $_POST['mount'], $_POST['device'], $oss);
    Save_Complete($result);
  }

  echo '</td><td bgcolor="#CCCCCC" width="5px"></td></tr><tr bgcolor="#CCCCCC"><td colspan="4" height="5px"></td></tr><tr><td colspan="5" height="5px"></td></tr></table>';
  if (!IsOnline() || IsFactory())
    echo '<table border="0" width="100%"><tr><td width="80%">'.MakeButton(TR('MSG_EXIT').' '.TR('MSG_DIAGNOSTICS'), 'parent.frames.headerFrame.exit();').'</td><td align="right">'.MakeButton(TR('MSG_PRINT'), 'window.print();').'</td><td align="right">'.MakeButton(TR('MSG_SAVE'), 'DisplaySaveDiv()').'</td></tr>';
  else
    echo '<table border="0" width="100%"><tr><td width="80%">&nbsp;</td><td align="right">'.MakeButton(TR('MSG_PRINT'), 'window.print();').'</td><td align="right">'.MakeButton(TR('MSG_SAVE'), 'DisplaySaveDiv()').'</td></tr>';

  echo '</table>';
  echo '</td></tr></table>';

  if ($HTTP_POST_VARS['save'] == '1') // keep savePrompt displayed
    echo 'document.getElementById("savePrompt").style.display = "inline";'."\n".'document.getElementById("savePrompt").style.visibility = "visible";'."\n";

  echo '</script>';

  echo '<script type="text/javascript">'."\n".'document.getElementById("wait").style.visibility="hidden";'."\n".'document.getElementById("wait").style.display="none";'."\n".'</script>';
  
?>
</form>
<script type="text/javascript" src="norightclick.js"></script>
</body>
</html>